local wave = require "wave"

local sData = love.sound.newSoundData "Example.ogg"

wave.save{ filename = "Example.wav", sound = sData, overwrite = true, callback = function() love.graphics.setColor(255, 0, 0) end}

local t = {}

t.bitDepth = 16
t.channels = 1
t.sampleRate = 48000

local BIRATEPI = t.sampleRate/math.pi/2

local sine = function(s, v, a) return a*math.sin(s*v/BIRATEPI) end

for i = 1, t.sampleRate*15 do
    t[i] = sine(i, 220, 2)
end

local sin = wave.save{ sound = t, filename = "Sine.wav", callback = function() love.system.openURL(love.filesystem.getSaveDirectory()) end, overwrite = true, exceptionMode = "normalize" }

love.update = function(dt)
    wave.update(dt)
end

love.draw = function()
    love.graphics.print("This is not a fancy demo. If everything is red, the .ogg file was saved as a wav file.\nWhen the following's done, a folder will automagically be opened.", 0, 0)
    local p = sin:getPercent()
    if p then
        love.graphics.print(p .. "%", 0, 32)
    end
    local s = sin:getStatus()
    if s then
        love.graphics.print(s, 0, 48)
    end
    if sin:getError() then
        love.graphics.print(sin:getError(), 0, 64)
    end
end

--love.threaderror = function(t, e)
--    wave.threaderror(t, e)
--end